;=======================================
; EGP02_ASM.s
; C[`
;=======================================
; Rev 00 : 2016.03.21 Konya (New Release)
;=======================================
;.include "p24FJ64GA004.inc"
.include "xc.inc"

;---------------------------------------------
;Configuration
;---------------------------------------------
config __CONFIG1, JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & ICS_PGx1 & FWDTEN_OFF 
;config __CONFIG2, IESO_OFF & FNOSC_FRC & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE
config __CONFIG2, IESO_OFF & FNOSC_FRCDIV & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE
;---------------------------------------------
;O[oϐ&֐錾
;---------------------------------------------
;ϐ
    .global __reset         ;The label for the first line of code. 
    .global DataLoc

    .global __OC1Interrupt    ;Declare OC1 ISR name global
    .global __OC2Interrupt    ;Declare OC2 ISR name global
    .global __ADC1Interrupt   ;Declare AD1 ISR name global
    .global _Snd0_ST		;TEh0pXe[^X		
    .global _Snd1_ST		;TEh1pXe[^X	

    .global _FlsData00		;tbVݗpWX^00
    .global _FlsData01		;tbVݗpWX^01
    .global _FlsData02		;tbVݗpWX^02
    .global _FlsData03		;tbVݗpWX^03
    .global _FlsData04		;tbVݗpWX^04
    .global _FlsData05		;tbVݗpWX^05
    .global _FlsData06		;tbVݗpWX^06
    .global _FlsData07		;tbVݗpWX^07
    .global _FlsData08		;tbVݗpWX^08
    .global _FlsData09		;tbVݗpWX^09
    
;֐
    .global _Wait_ms		; EFCg msP(FWait@ߒlFȂ)
    .global _PicIni		; PIC(FȂ@ߒlFȂ)
    .global _RTCIni		; RTC(FȂ@ߒlFȂ)
    .global _RTCWrEn		; RTC(FȂ@ߒlFȂ)    
    .global _LcdIni		;LCD(FȂ@ߒlFȂ)
    .global _LcdClr		;LCD\NA(FȂ@ߒlFȂ)
    .global _LcdNorV		;LCD㉺](FȂ@ߒlFȂ)
    .global _LcdRevV		;LCD㉺](FȂ@ߒlFȂ)
    .global _VR_CWT		; PICVRAMւ̃LN^`(\tO=0̂Ƃ\Ȃ)(F`X,Y,f[^擪AhX,p^[ԍ,\tO ߒlFȂ)
    .global _VR_CWT2		; PICVRAMւ̃LN^`(\tO=0̂Ƃ\)(F`X,Y,f[^擪AhX,p^[ԍ,\tO ߒlFȂ)
    .global _VR_LCDDraw		; PICVRAM LCDꊇ](F@Ȃ ߒlFȂ)
    .global _VR_StrDraw		; PICVRAMւ̕`(F`X,Y,p^[ԍ,F,Font ߒlFȂ)
    .global _VR_AllClr		; PICVRAMI[NA(FNApbgԍ ߂lFȂ)
    .global _SndSet0		; TEh0o
    .global _SndSet1		; TEh1o
    .global _FlsWr		; tbV
    .global _FlsRd		; tbVǂݏo
;---------------------------------------------
;(file register)`
;---------------------------------------------
;Near data memory
    .section .usrram, bss, near
	BLNK:	     .space 64
	VRAM:	     .space 1152	;PIC Video RAM(128dot x 8byte(64dot) +128byte(͂ݏoی앪))
;TEhp
    ;+0 TEhf[^CfbNXAhX
    ;+2 TEhf[^ŏICfbNXAhX
    ;+4 TEhf[^i[AhX擪(tbloffset)
	_Snd0_ST:   .space 8		;TEh0pXe[^X
	_Snd1_ST:   .space 10		;TEh1pXe[^X

;tbVݗp
	_FlsData00:  .space 2
	_FlsData01:  .space 2
	_FlsData02:  .space 2
	_FlsData03:  .space 2
	_FlsData04:  .space 2
	_FlsData05:  .space 2
	_FlsData06:  .space 2
	_FlsData07:  .space 2
	_FlsData08:  .space 2
	_FlsData09:  .space 2
  
;***************************************************************
;֘A֐
;***************************************************************
.text					;Start of Code section
;---------------------------------------------
;}N`
;---------------------------------------------
	.include "EGP02_Macro.inc"
;---------------------------------------------
;PIC(NbNA|[gAW[)ݒ
;---------------------------------------------
;F@Ȃ
;ߒlF@Ȃ
_PicIni:
    ;CLKݒ
	MOV	#0x0300,w0		; CLKCDIV(bit10-8)=3(8)
	MOV	w0, CLKDIV		; 
    ;PORTݒ
	MOV	#0x1FFE,w0		;AD1PCFG
	MOV	w0, AD1PCFG		;AN1 Analog input ,other Digital I/O

	MOV	#0x03FF,w0		;TRISA
	MOV	w0, TRISA		;RA0-9 = Digital input

	MOV	#0xFC0C,w0		;TRISB
	MOV	w0, TRISB		;RB15,14,13,12,11,10,3,2 = Digital input, other = output

	MOV	#0x0000,w0		;TRISC
	MOV	w0, TRISC		;RC7,6 = Digital input, other = output
    ;PULL UPݒ
	MOV	#0xF8C0,w0		;CNPU1
	MOV	w0, CNPU1		;CN15,14,13,12,11,7,6 = pllup ON
	MOV	#0x0001,w0		;CNPU2
	MOV	w0, CNPU2		;CN16 = pllup ON
	
    ;SPIݒ
	MOV	#0x0708,w0		;P#4 RP24= SPI CLK OUT
	MOV	w0, RPOR12		;P#5 RP25= SPI DATA OUT	
    
	MOV	#0x007F,w0
	MOV	w0, SPI1CON1
	BCLR	SPI1STAT, #6
	BSET	SPI1STAT, #15

    ;o̓RyA荞ݐݒ
	MOV	#0x1200,w0		;P#36  RP19 = Output Compare1
	MOV	w0, RPOR9		;
	MOV	#0x0013,w0		;P#37  RP20 = Output Compare1
	MOV	w0, RPOR10		;
		
	MOV	#0x0000,w0
	MOV	w0, OC1CON		;o̓RyA
	MOV	#0x0005,w0
	MOV	w0, OC1CON		;fArv[h-Ao	

	BSET	IPC0, #OC1IP0		;
	BCLR	IPC0, #OC1IP1		;
	BCLR	IPC0, #OC1IP2		;
	BCLR	IFS0, #OC1IF		;
	BSET	IEC0, #OC1IE		;

	MOV	#0x0000,w0
	MOV	w0, OC2CON		;o̓RyA
	MOV	#0x000d,w0
	MOV	w0, OC2CON		;fArv[h-Ao	

	BSET	IPC0, #OC2IP0		;
	BCLR	IPC0, #OC2IP1		;
	BCLR	IPC0, #OC2IP2		;
	BCLR	IFS0, #OC2IF		;
	BSET	IEC0, #OC2IE		;
		
	RETURN
;---------------------------------------------
;RTCݒ
;---------------------------------------------
_RTCIni:

	MOV	#OSCCON, w1
        MOV.b	#0x02, w0
        MOV.b	#0x46, w2
        MOV.b	#0x57, w3
	MOV.b	w2, [w1]
	MOV.b	w3, [w1]
	MOV.b	w0, [w1]

	CALL	_RTCWrEn			;ԐݒύX

	BSET	RCFGCAL, #8
	BSET	RCFGCAL, #9
	MOV	#RTCVAL, w1
	MOV	#0x0017, w0			; ,N
	MOV	w0, [w1]
	MOV	#0x0122, w0			;,
	MOV	w0, [w1]
	MOV	#0x0023, w0			;j,
	MOV	w0, [w1]
        MOV	#0x5900, w0			;,b
        MOV	w0, RTCVAL
;	BSET	RCFGCAL, #RTCOE
;	BSET	PADCFG1, #RTSECSEL
	BSET	RCFGCAL, #RTCEN


	BCLR	RCFGCAL, #RTCWREN
	RETURN		

;---------------------------------------------
;RTC Ԑݒ苖
;---------------------------------------------
_RTCWrEn:
	DISI	#5
	MOV	#0x0055,w7
	MOV	w7, NVMKEY
	MOV	#0x00AA,w7
	MOV	w7, NVMKEY
	BSET	RCFGCAL, #RTCWREN
	NOP
	NOP
	RETURN		
;---------------------------------------------
;LCD 
;---------------------------------------------
_LcdIni:
    ;BackLLight off
	BSET LATB,#8		;Back Light off
	
    ;RESET 
	mLCD_RST_Clr		;LCDZbg

	MOV	#0x0001,w0
	CALL	_Wait_ms

	mLCD_RST_Set		;LCDZbg
	mLCD_CS0_CLR		;LCD CS=0
    ;S/W RESWT
	mLCDCMD  #0x00E2

    ; LCD bias
	mLCDCMD  #0x00A3

    ;SEG Direction @A0:NORMAL A1:REVERSE	
	mLCDCMD  #0x00A1
    ;COM Direction   C0:NORMAL C8:REVERSE
	mLCDCMD  #0x00C0

    ;Regultion resistor select  
	mLCDCMD  #0x0022
    ;Set EV
	mLCDCMD  #0x0081
    ;EV value.
	mLCDCMD  #0x002A
		
    ;Power control
	mLCDCMD  #0x002F

    ;Set Start Line
	;	mLCDCMD  #0x0040
    ;Set page address(Y=0ɐݒ)
	;	mLCDCMD  #0x00B0
    ;Set coloumn addr MSB
	;	mLCDCMD  #0x0010
    ;Set coloumn addr LSB(
	;	mLCDCMD  #0x0000
		
    ;Inverse Display    A6:NORMAL A7:REVERSE
	mLCDCMD  #0x00A6

    ;CALL _LcdClr

    ;/DisPlay On
	mLCDCMD  #0x00AF

	RETURN

;--------------------------
;LCDI[NA
;--------------------------
_LcdClr:
;Set Start Line
;	mLCDCMD #0x40

;Set Page Address
	MOV	#0xB0, w12

LcdClr_LpPag:
	mLCDCMD w12

;Set Column Address
	mLCDCMD #0x10
	mLCDCMD #0x00
	
;Coloum Loop
	MOV 	#131, w3
LcdClr_LpClm:
;Write Data
	mLCDDAT #0x00
	DEC	w3, w3
	BTSS	SR, #Z
	GOTO	LcdClr_LpClm
	INC	w12, w12
	MOV	#0xB8, w4
	CPSEQ	w12, w4 		
	GOTO	LcdClr_LpPag

	RETURN
;--------------------------
;LCD㉺]
;--------------------------
_LcdNorV:
    ;SEG Direction @A0:NORMAL A1:REVERSE	
	mLCDCMD  #0x00A1
    ;COM Direction   C0:NORMAL C8:REVERSE
	mLCDCMD  #0x00C0
	
	RETURN
;--------------------------
;LCD㉺]
;--------------------------
_LcdRevV:
    ;SEG Direction @A0:NORMAL A1:REVERSE	
	mLCDCMD  #0x00A0
    ;COM Direction   C0:NORMAL C8:REVERSE
	mLCDCMD  #0x00C8
	
	RETURN
	
;--------------------------
;P-VRAMI[NA
;--------------------------
_VR_AllClr:
	MOV	#512, w2			;w2=VRAM(128dot x 8byte /2)
	MOV	#VRAM, w3			;w3=VRAM Address
VR_Clr_lp:
	MOV	#0000, w1
	MOV	w1, [w3++]			;w1=VRAM data
	DEC	w2, w2
	BTSS	SR,#Z
	GOTO	VR_Clr_lp
	RETURN

;***************************************************************
;`֘A֐
;***************************************************************
;--------------------------
;PICVRAMւ̃LCg
;--------------------------
;w0=X
;w1=Y
;w2=Lf[^擪AhX(tableoffset) 
;w3=\p^[ԍ
;w4=\tO  0    :`悵Ȃ(Lf[^ALL0ɒuAVRAMɏ)@
;  	@@@@0ȊO:`悷
_VR_CWT:
    ;擪AhX(PICVRAM)Zo(adr = y/8 *128 + x + VRAM offset ADR)
	LSR	w1, #3, w6 	; w6 = Y / 8(hbg -> oCgAhXɕϊ)
	MOV	#128, w13	;
	MUL.UU	w6, w13, w6	; w6 = w6 * 128 	
	ADD	w6, w0, w6	; w6 = w6 + x
	MOV	#VRAM, w0	;
	ADD	w6, w0, w5	; w5 = w6 + VRAM offset ADR

	AND	w1, #7, w1	;w1 = Y[2:0](c̃rbgVtgl)
    ;chr size擾ichr data̐擪2oCgsizeX,sizeYj
	CLR	w6
	CLR	w7
	TBLRDL.b    [w2++], w6	;w6 =sizeX(chr data tbloffset)
	TBLRDL.b    [w2++], w7	;w7 =siZeY(chr data tbloffset)
	LSR	w7,#3, w7	;SizeY /8(8dot1bytê)

	MUL.UU	w6, w7, w10	;f[^      (w10 = SizeY/8 *SizeX)           
	MUL.UU	w3, w10, w10	;p^[AhX   (w10=f[^*p^[ԍ)
	ADD	w10, w2,w2	;Lf[^AhX (w2=Lf[^AhX+p^[AhX)
	
VR_CWT_LpY:
;loopY
	MOV    w6, w12		;w12(LoopX Number) = sizeX
	MOV    w5, w3		;W3w5(VARMAhX)Ҕ
VR_CWT_LpX:
  ;loopX
    ;Lf[^ǂݍ
	CLR	w8
	CPSEQ	w4, W8          ;L\tO(w4)=0̂ƂALf[^ǂݍ݂XLbvBLf[^=ALL0ƂB
	TBLRDL.b   [w2++], w8	;w8 = Lf[^
	
    ;W1-7̓Lf[^rbgVtgĂuq`l֏
	;Lf[^@VtgʃoCg
	SL	w8, w1, w9	;@Lf[^ւ1rbgVtg
	;Lf[^@VtgʃoCg
	SUBR	w1, #8, w10
	LSR	w8, w10, w8	;@Lf[^(8-1)rbgVtg

    ;Lf[^VRAMɓ]
    	;ʃf[^]
	ADD	w5, w13, w10    ;w10 = VRAMAhX +128
	MOV.b	[w10], w11	; w11=VRAM̒l 
	IOR	w8, w11, w8	; VRAMƃLf[^dˍ킹
	MOV.b	w8, [w10]	; ʃf[^]
	;ʃf[^]
	MOV.b	[w5], w11	; w11=VRAM̒l
	IOR	w9, w11, w9	; VRAMƃLf[^dˍ킹
	MOV.b	w9, [w5++]	; ʃf[^]

  ;loopXI
	DEC	w12, w12	;LoopX = LoopX-1
	BRA	NZ,VR_CWT_LpX	;if LoopX <>0 then goto LpX
;loopYI
	MOV	w3, w5		;VRAMAhXɖ߂
	ADD	w5, w13, w5	;VRAMAhX+128
	MOV	#1024,w11
	ADD	w0, w11, w10	;w11=VRAM offset ADR +1024 
	CPSLT	w5,w10		;if VRAMAhX>=VRAMAhXől
	GOTO	VR_CWT_END	;then END
	DEC	w7, w7		;LoopY = LoopY-1
	BRA	NZ,VR_CWT_LpY	;if LoopY <>0 then goto LpY
VR_CWT_END:
	RETURN

;--------------------------
;PICVRAMւ̃LCg2
;
;--------------------------
;w0=X
;w1=Y
;w2=Lf[^擪AhX(tableoffset) 
;w3=\p^[ԍ
;w4=`tO  0    :`悵Ȃ(Lf[^iqɃ}XNVRAMɏ)@
;  	@@@@0ȊO:`悷
_VR_CWT2:
    ;擪AhX(PICVRAM)Zo(adr = y/8 *128 + x + VRAM offset ADR)
	LSR	w1, #3, w6 	; w6 = Y / 8(hbg -> oCgAhXɕϊ)
	MOV	#128, w13	;
	MUL.UU	w6, w13, w6	; w6 = w6 * 128 	
	ADD	w6, w0, w6	; w6 = w6 + x
	MOV	#VRAM, w0	;
	ADD	w6, w0, w5	; w5 = w6 + VRAM offset ADR

	AND	w1, #7, w1	;w1 = Y[2:0](c̃rbgVtgl)
    ;chr size擾ichr data̐擪2oCgsizeX,sizeYj
	CLR	w6
	CLR	w7
	TBLRDL.b    [w2++], w6	;w6 =sizeX(chr data tbloffset)
	TBLRDL.b    [w2++], w7	;w7 =siZeY(chr data tbloffset)
	LSR	w7,#3, w7	;SizeY /8(8dot1bytê)

	MUL.UU	w6, w7, w10	;f[^      (w10 = SizeY/8 *SizeX)           
	MUL.UU	w3, w10, w10	;p^[AhX   (w10=f[^*p^[ԍ)
	ADD	w10, w2,w2	;Lf[^AhX (w2=Lf[^AhX+p^[AhX)
	
VR_CWT2_LpY:
;loopY
	MOV    w6, w12		;w12(LoopX Number) = sizeX
	MOV    w5, w3		;W3w5(VARMAhX)Ҕ
VR_CWT2_LpX:
  ;loopX
    ;Lf[^ǂݍ
	CLR	w8
	TBLRDL.b   [w2++], w8	;w8 = Lf[^
    ;}XN\@W4 = 0̂ƂLf[^iqɃ}XNĔlɕ\
	MOV	#0x55, w9
	BTSS	w12, #1
	MOV	#0xAA, w9
	BTSS	w12, #0
	MOV     #0x00, w9
	
	CLR	W10
	CPSNE	W4, W10
	AND	w8, w9, w8	
    ;W1-7̓Lf[^rbgVtgĂuq`l֏
	;Lf[^@VtgʃoCg
	SL	w8, w1, w9	;@Lf[^ւ1rbgVtg
	;Lf[^@VtgʃoCg
	SUBR	w1, #8, w10
	LSR	w8, w10, w8	;@Lf[^(8-1)rbgVtg

    ;Lf[^VRAMɓ]
    	;ʃf[^]
	ADD	w5, w13, w10    ;w10 = VRAMAhX +128
	MOV.b	[w10], w11	; w11=VRAM̒l 
	IOR	w8, w11, w8	; VRAMƃLf[^dˍ킹
	MOV.b	w8, [w10]	; ʃf[^]
	;ʃf[^]
	MOV.b	[w5], w11	; w11=VRAM̒l
	IOR	w9, w11, w9	; VRAMƃLf[^dˍ킹
	MOV.b	w9, [w5++]	; ʃf[^]

  ;loopXI
	DEC	w12, w12	;LoopX = LoopX-1
	BRA	NZ,VR_CWT2_LpX	;if LoopX <>0 then goto LpX
;loopYI
	MOV	w3, w5		;VRAMAhXɖ߂
	ADD	w5, w13, w5	;VRAMAhX+128
	MOV	#1024,w11
	ADD	w0, w11, w10	;w11=VRAM offset ADR +1024 
	CPSLT	w5,w10		;if VRAMAhX>=VRAMAhXől
	GOTO	VR_CWT_END	;then END
	DEC	w7, w7		;LoopY = LoopY-1
	BRA	NZ,VR_CWT2_LpY	;if LoopY <>0 then goto LpY
VR_CWT2_END:
	RETURN

;--------------------------
;PICVRAMLCDֈꊇ]
;--------------------------
_VR_LCDDraw:
    	MOV	#VRAM, w10	;w8=P-VRAMŏIAhX
    ;Set Page Address
	MOV	#0x00B0, w12

Lcd_SA_LpPag:
    ;Set Page Address
	mLCDCMD w12

    ;Set Column Address
	mLCDCMD #0x0010
	mLCDCMD #0x0000

    ;Coloum Loop
	MOV 	#128, w3		;w3=TCY 128dot
Lcd_SA_LpClm:
    ;Write Data
	MOV.b	[w10++], w1		;w1=P-VRAM data
	mLCDDAT w1
	DEC	w3, w3			;TCYf[^CgA
	BTSS	SR, #Z			;܂Ń[vB
	GOTO	Lcd_SA_LpClm		;

	INC	w12, w12		;Page Address +1
	MOV	#0xB8, w4		;0-7pgae
	CPSEQ	w12, w4 		;I
	GOTO	Lcd_SA_LpPag		;

	RETURN
;--------------------------
;SPIf[^M
;--------------------------
;w1=Send DATA

LCD_Send:
	BTSC	SPI1STAT, #1		; SPISTAT bit1(SPITBFFSPIMobt@t)|[OB
	GOTO	LCD_Send		;@SPITBF = 0ɂȂ܂Ń[vB
	MOV	w1, SPI1BUF
	RETURN
	

;--------------------------------------------------
;@PICVRAMւ̕`
;--------------------------------------------------
;Fw0=XW,@w1=YW,w3=\p^[ԍ(A-Z Ascllԍ), w2=tHg0or1
;ߒlFȂ
_VR_StrDraw:
;		PUSH	w14

	BTSC	w2, #0
	GOTO	VRSD_Fnt1

	MOV	#tblpage(_FontS),w2
	MOV	w2, _TBLPAG
	MOV	#tbloffset(_FontS),w2
	GOTO	VRSD_GenPtnNo	
VRSD_Fnt1:
	MOV	#tblpage(_FontM),w2
	MOV	w2, _TBLPAG
	MOV	#tbloffset(_FontM),w2
VRSD_GenPtnNo:
	MOV	#0x41, w10
	SUB	w3, w10, w3
	GOTO	_VR_CWT	

;-----------------------
;@EFCg
;-----------------------
;w1=EFCg(1`0xFFFF)
Wait1u:
	NOP
	DEC	w1,w1
	BRA	NZ,Wait1u
	RETURN

;w1=EFCgʃ[h(1`0xFFFF)
_Wait_ms:
	MOV	 #2000, w2		;w2=EFCgʃ[h
;	MOV	 #8000, w2		;w2=EFCgʃ[h
Wait_ms00:
	NOP
	NOP
	NOP
	DEC	w2,w2
	BRA	NZ,Wait_ms00
	DEC	w0,w0
	BRA	NZ,_Wait_ms

	RETURN
	 		
;***************************************************************
;TEh֘A
;***************************************************************
;==========================
;TEh0 o͏ݒ
;==========================
;Fw0=ʉf[^i[ 擪AhX
;ߒlFȂ
_SndSet0:
	MOV	#1,w3		;U=1
	MOV	#_Snd0_ST,w2	;
	MOV	w3,[w2++]	;_Snd0_ST +0 =U
	INC2	w2, w2		;
	MOV	w0, [w2++]	;_Snd0_ST +4 =ʉf[^擪AhX
	MOV	#0, w3		;CfbNXAhX=0
	MOV	w3, [w2]	;_Snd0_ST +4 =CfbNXAhX	
	MOV	#1,w0		;
	MOV	w0, OC1R	;オl(_~[)=1 
	MOV	#2,w0		;
	MOV	w0, OC1RS	;l(_~[)=2 
	MOV	#0xFFFF,w0	;
	MOV	w0, PR2		;(_~[) =0xFFFF
	MOV	w0, TMR2	;^C}[2[NA
	BSET	T2CON, #TON	;^C}[2Jn	
	RETURN

;==========================
;TEh1 o͏ݒ
;==========================
;Fw0=ʉf[^i[ 擪AhX
;ߒlFȂ
_SndSet1:
	MOV	#1,w3		;U=1
	MOV	#_Snd1_ST,w2	;
	MOV	w3,[w2++]	;_Snd0_ST +0 =U
	INC2	w2, w2		;
	MOV	w0, [w2++]	;_Snd0_ST +4 =ʉf[^擪AhX
	MOV	#0, w3		;CfbNXAhX=0
	MOV	w3, [w2]	;_Snd0_ST +4 =CfbNXAhX		
	MOV	#1,w0		;
	MOV	w0, OC2R	;オl(_~[)=1 
	MOV	#2,w0		;
	MOV	w0, OC2RS	;l(_~[)=2 
	MOV	#0xFFFF,w0	;
	MOV	w0, PR3		;(_~[) =0xFFFF
	MOV	w0, TMR3	;^C}[3[NA
	BSET	T3CON, #TON	;^C}[3Jn	
	RETURN

;***************************************************************
;ݏ
;***************************************************************
;==========================
;OC1
;==========================
__OC1Interrupt:

	PUSH	w0
	PUSH	w1
	PUSH	w2
	PUSH	w3

		
	MOV	#_Snd0_ST, w0	;
	MOV	[w0], w1	;
	DEC	w1, w1		;UJE^-1="0"łȂ
	MOV	w1, [W0++]	;荞ݏI
	BRA	NZ, OC1INT_End	;"0"Ȃ,̃TEhf[^ݒ
OC1INT_setdt:
	MOV	#_Snd0_ST+4, w0	;
	MOV	[w0++], w1 	;w1=tbloffset
	MOV	[w0], w2	;w2=index
	PUSH	w2
	INC2	w2, w2		;Snd_ST(index)=+2
	INC2	w2, w2		;Snd_ST(index)=+2
	MOV	w2, [w0]	;
	POP	w2
	ADD	w2, w1, w1	;w1=tbloffset + index
	TBLRDL	[w1++], w2	;w2 = TEhf[^(U)
	MOV	#0xFFFF, w3	;
	CPSNE	w2, w3		;U=0xFFFFȂ
	GOTO	OC1INT_sndend	;TEho͏I
	MOV	#0xFFFE, w3	;
	CPSNE	w2, w3		;U=0xFFFEȂ
	GOTO	OC1INT_sndloop	;TEh[v
	MOV	#_Snd0_ST, w0	;
	MOV	w2, [w0++]	;U񐔂Snd_stɐݒ
	TBLRDL	[w1++], w2	;w2 = TEhf[^()
	MOV	#0, w3		;
	CPSNE	w2, w3		;=0Ȃ
	GOTO	OC1INT_setnosnd	;ݒ		
	MOV	w2, [w0++]	;Snd_stɐݒ
	MOV	w2, PR2		;PR2ɐݒ
	MOV	w2, OC1RS	;OC1RSɐݒ(l)
	LSR	w2, w2		;
	MOV	w2, OC1R	;/2OC1RSɐݒ(オl)				
	GOTO	OC1INT_End
OC1INT_setnosnd:
    ;ݒ
	MOV	#1000, w2
	MOV	w2, [w0++]	;Snd_stɐݒ
	MOV	w2, PR2		;PR2ɐݒ
;	DEC	w2, w2
	MOV	w2, OC1RS	;OC1RSɐݒ(l)
	DEC	w2, w2		;
	MOV	w2, OC1R	;オłȂlݒ				
	GOTO	OC1INT_End
OC1INT_sndloop:
	MOV	#0, w3		;Xe[^XWX^
	MOV	#_Snd0_ST+6, w0	;CfNXAhX="0"ɂ
	MOV	w3, [w0]	;TEhf[^ݒ
	GOTO	OC1INT_setdt	;
OC1INT_sndend:
    ;g`o͒~
	BCLR	T2CON, #TON	;^C}[2~		

OC1INT_End:
        BCLR IFS0, #OC1IF		;݃tONA
 
	POP	w3
	POP	w2                          
	POP	w1
	POP	w0
        RETFIE   

;==========================
;OC2
;==========================
__OC2Interrupt:

	PUSH	w0
	PUSH	w1
	PUSH	w2
	PUSH	w3

	MOV	#_Snd1_ST, w0	;
	MOV	[w0], w1	;UJE^-1="0"łȂ
	DEC	w1, w1		;荞ݏI
	MOV	w1, [W0++]	;
	BRA	NZ, OC2INT_End	;"0"Ȃ,
OC2INT_setdt:
    ;TEhf[^ݒ
	MOV	#_Snd1_ST+4, w0	;		
	MOV	[w0++], w1 	;w1=tbloffset
	MOV	[w0], w2	;w2=index
	PUSH	w2
	INC2	w2, w2		;Snd_ST(index)=+2
	INC2	w2, w2		;Snd_ST(index)=+2
	MOV	w2, [w0++]	;
	POP	w2
	ADD	w2, w1, w1	;w1=tbloffset + index
	TBLRDL	[w1++], w2	;w2 = TEhf[^(U)
	MOV	#0xFFFF, w3	;
	CPSNE	w2, w3		;U=0xFFFFȂ
	GOTO	OC2INT_sndend	;TEho͏I
	MOV	#0xFFFE, w3	;
	CPSNE	w2, w3		;U=0xFFFEȂ
	GOTO	OC2INT_sndloop	;TEh[v
	MOV	#_Snd1_ST, w0	;
	MOV	w2, [w0++]	;U񐔂Snd_stɐݒ
	TBLRDL	[w1++], w2	;w2 = TEhf[^()
	MOV	#0, w3		;
	CPSNE	w2, w3		;=0Ȃ
	GOTO	OC2INT_setnosnd	;ݒ		
	MOV	w2, [w0++]	;Snd_stɐݒ
	MOV	w2, PR3		;PR2ɐݒ
	MOV	w2, OC2RS	;OC1RSɐݒ(l)
	LSR	w2, w2		;
	MOV	w2, OC2R	;/2OC1RSɐݒ(オl)				
	GOTO	OC2INT_End
OC2INT_setnosnd:
    ;ݒ
	MOV	#1000, w2
	MOV	w2, [w0++]	;Snd_stɐݒ
	MOV	w2, PR3		;PR2ɐݒ
;	DEC	w2, w2
	MOV	w2, OC2RS	;OC1RSɐݒ(l)
	DEC	w2, w2		;
	MOV	w2, OC2R	;オłȂlݒ				
	GOTO	OC2INT_End
OC2INT_sndloop:
	MOV	#0, w3		;Xe[^XWX^
	MOV	#_Snd1_ST+6, w0	;CfNXAhX="0"ɂ
	MOV	w3, [w0]	;TEhf[^ݒ
	GOTO	OC2INT_setdt	;
OC2INT_sndend:
    ;g`o͒~
	BCLR	T3CON, #TON	;^C}[3~		

OC2INT_End:
	BCLR	IFS0, #OC2IF    ;݃tONA
 
	POP	w3
	POP	w2                          
	POP	w1
	POP	w0
        RETFIE   
;***************************************************************
;ݒl̃Z[uA[h
;***************************************************************
;==========================
;ݒlZ[u
;==========================
_FlsWr:
	MOV	#0x9F00,w12		;݃AhX=0x9F00
	MOV	#_FlsData00, W2 	;݃f[^i[AhX

    ;tbV 
	MOV	#0x4042, W0
	MOV	W0, NVMCON 
	TBLWTL	W12, [W12] 
	DISI	#5 			;L[bN̊ԁA݋֎~(5+1cyc)
	MOV	#0x55, W0
	MOV	W0, NVMKEY
	MOV	#0xAA, W1
	MOV	W1, NVMKEY
	BSET	NVMCON, #WR 
	NOP 
	NOP
Fls_wt_Lp0:
	BTSC	NVMCON, #WR
	GOTO	Fls_wt_Lp0

    ;tbV
	MOV	#10, w1
Fls_wt_Lp1:
	CLR	w3
	MOV	[w2++], w5
	TBLWTL	W5, [W12] 		
	TBLWTH	W3, [W12++] 		
	DEC	w1, w1
	BRA	NZ, Fls_wt_Lp1
	MOV	#63, w0
	MOV	#0xFFFF,w2
	MOV	#0x4001, W0 	
	MOV	W0, NVMCON 	
	DISI	#5		;L[bN̊ԁA݋֎~(5+1cyc)
	MOV	#0x55, W0 	
	MOV 	W0, NVMKEY
	MOV	#0xAA, W0
	MOV	W0, NVMKEY
	BSET	NVMCON, #WR		
	NOP
	NOP
Fls_wt_Lp:
	BTSC	NVMCON, #WR
	GOTO	Fls_wt_Lp
	RETURN

;==========================
;ݒl[h
;==========================
_FlsRd:

	MOV	#0x9F00,w12		;ǏoAhX=0x9F00
	MOV	#_FlsData00, w2	;ǂݏof[^i[擪AhX
	MOV	#10, w10		;ǂݏo = 10
	MOV	#0xFFFF,w1
LS_Loop:	
	CLR	w0		
	TBLRDL	[w12++], w0
	CPSNE	w0, w1			;ǂ݂f[^0xFFFF
	CLR	w0			;0x0000ɕύXB
	MOV	w0, [w2++]
	
	DEC	w10, w10		;ǂݏoJԂ
	BRA	NZ, LS_Loop		

	RETURN	

	
;***************************************************************
;LATEhȂf[^
;***************************************************************
;==================================================
;Chr Data
;==================================================

    .include "ChrDataCmn.inc"
    .include "ChrData.inc"
;==========================
;TEhf[^
;==========================
.global	_snd_piggy

_snd_piggy:
;N
    .word       60, 0x300 	;h 
    .word       50,0x0000 	;
    .word      400, 0x150 	;h 
    .word       10,0x0000 	;
    .word   0xFFFF,0 		;I}[N 


;Sound DATA
    .include "SndData.inc"

;=============================================
;END
;=============================================
.end